<template>
  <div
    v-if="value"
    :class="onlyPwd ? 'q-pa-sm' : 'q-px-sm'"
  >
    <q-card
      :class="{ 'row justify-evenly content-start fit': !onlyPwd && isUser }"
      :bordered="!onlyPwd && isUser"
      flat
    >
      <q-card-section
        v-if="title && !onlyPwd"
        class="col-12"
      >
        <div class="text-h5 text-weight-bolder text-grey-9 q-px-sm q-pt-sm">
          {{ title }}
        </div>
      </q-card-section>

      <q-card-section
        v-if="!onlyPwd && isUser && showCroppa"
        class="col-4 self-center"
      >
        <croppa
          ref="takeScreenshot"
          :initial-image="initialImage"
          :show-remove-button="true"
          canvas-color="transparent"
          :accept="'image/*'"
          :zoom-speed="10"
          :height="250"
          :width="250"
          :quality="1"
          placeholder
          prevent-white-space
        >
          <img
            slot="placeholder"
            src="~assets/user.png"
          >
        </croppa>
      </q-card-section>

      <q-card-section :class="{ 'col-6': !onlyPwd }">
        <q-form :class="onlyPwd || !isUser ? 'row q-gutter-y-md' : 'row q-gutter-y-md q-pa-md'">
          <q-input
            v-if="!onlyPwd"
            v-model="value.name"
            class="col-12 q-pa-sm"
            label="Nome Completo"
            color="primary"
            bottom-slots
            outlined
            dense
            :disable="isUser && Boolean(userId)"
            :error="vuelidate.name.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.name)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-if="!onlyPwd"
            v-model="value.documentNumber"
            :class="isUser ? 'col-12 q-pa-sm' : 'col-6 q-pa-sm'"
            label="CPF"
            color="primary"
            mask="###.###.###-##"
            unmasked-value
            bottom-slots
            outlined
            dense
            :disable="isUser && Boolean(userId)"
            :error="vuelidate.documentNumber.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.documentNumber)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-if="!onlyPwd"
            ref="inputDate"
            v-model="value.bornAt"
            :class="isUser ? 'col-12 q-pa-sm' : 'col-6 q-pa-sm'"
            label="Data de Nascimento"
            color="primary"
            bottom-slots
            outlined
            dense
            :disable="isUser && Boolean(userId)"
            :error="vuelidate.bornAt.$error"
            @focus="$refs.popupDate.show()"
          >
            <template v-slot:append>
              <q-icon
                class="cursor-pointer"
                name="event"
              >
                <q-popup-proxy
                  ref="popupDate"
                  transition-show="scale"
                  transition-hide="scale"
                  @hide="$refs.inputDate.blur()"
                >
                  <q-date
                    v-model="value.bornAt"
                    :default-year-month="defaultYearMonth"
                    :options="options"
                    mask="DD/MM/YYYY"
                    landscape
                    minimal
                    @input="$refs.popupDate.hide()"
                  />
                </q-popup-proxy>
              </q-icon>
            </template>

            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.bornAt)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-if="!onlyPwd"
            v-model="value.phone"
            :class="isUser ? 'col-12 q-pa-sm' : 'col-6 q-pa-sm'"
            label="Telefone"
            color="primary"
            :mask="phoneMask"
            unmasked-value
            bottom-slots
            outlined
            dense
            :error="vuelidate.phone.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.phone)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-if="!onlyPwd"
            v-model="value.email"
            :class="isUser ? 'col-12 q-pa-sm' : 'col-6 q-pa-sm'"
            label="E-mail"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.email.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.email)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-if="onlyPwd"
            v-model="value.password"
            :type="isPwd ? 'password' : 'text'"
            class="col-6 q-pa-sm"
            label="Senha"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.password.$error"
          >
            <template v-slot:append>
              <q-icon
                class="cursor-pointer"
                :name="isPwd ? 'visibility_off' : 'visibility'"
                @click="isPwd = !isPwd"
              />
            </template>

            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.password)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-input
            v-if="onlyPwd"
            v-model="value.repeatPassword"
            :type="isPwd ? 'password' : 'text'"
            class="col-6 q-pa-sm"
            label="Confirmação da Senha"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="vuelidate.repeatPassword.$error"
          >
            <template v-slot:append>
              <q-icon
                class="cursor-pointer"
                :name="isPwd ? 'visibility_off' : 'visibility'"
                @click="isPwd = !isPwd"
              />
            </template>

            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.repeatPassword)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-input>

          <q-select
            v-if="!onlyPwd && !loggedUser"
            v-model="value.lstACL"
            :options="lstACL"
            :class="isUser ? 'col-12 q-pa-sm' : 'col-6 q-pa-sm'"
            label="Nível de Acesso"
            color="primary"
            options-cover
            options-dense
            bottom-slots
            map-options
            emit-value
            outlined
            dense
            :error="vuelidate.lstACL.$error"
          >
            <template v-slot:error>
              <div
                v-for="(errorMessage, index) in errorMessages(vuelidate.lstACL)"
                :key="index"
              >
                {{ errorMessage }}
              </div>
            </template>
          </q-select>
        </q-form>
      </q-card-section>

      <q-card-actions
        v-if="!onlyPwd && isUser"
        class="col-10 justify-center super-padding-top"
      >
        <q-btn
          class="full-width"
          :label="Boolean(userId) ? 'Atualizar' : 'Cadastrar'"
          color="primary"
          padding="12px"
          rounded
          @click="$emit('save')"
        />
      </q-card-actions>
    </q-card>
  </div>
</template>

<script>
import { GenerateDownloadURLMixin } from '../../mixin/generate-download-url'
import { ErrorMessagesMixin } from '../../mixin/error-messages'
import { isDate } from 'brazilian-values'
import { date } from 'quasar'

export default {
  name: 'User',
  mixins: [GenerateDownloadURLMixin, ErrorMessagesMixin],
  props: {
    value: {
      type: Object,
      default: () => ({})
    },
    vuelidate: {
      type: Object,
      default: () => ({})
    },
    title: {
      type: String,
      default: () => ('')
    },
    userId: {
      type: Number,
      default: () => (null)
    },
    onlyPwd: {
      type: Boolean,
      default: () => (false)
    },
    isUser: {
      type: Boolean,
      default: () => (true)
    }
  },
  data () {
    return {
      isPwd: true,
      initialImage: '',
      showCroppa: false,
      lstACL: [
        { label: 'Aluno', value: 'authenticated' },
        { label: 'Professor', value: 'teacher' },
        { label: 'Administrador', value: 'admin' }
      ]
    }
  },
  computed: {
    phoneMask () {
      return this.value.phone.length < 11 ? '(##) ####-#####' : '(##) #####-####'
    },
    defaultYearMonth () {
      return date.formatDate(date.subtractFromDate(new Date(), { year: 18 }), 'YYYY/MM')
    },
    loggedUser () {
      return this.$store.state.session.user.id === this.userId
    }
  },
  watch: {
    'value.bornAt' (bornAt) {
      if (!isDate(bornAt)) {
        this.value.bornAt = ''
      }
    },
    value: {
      deep: true,
      handler (value) {
        if (typeof value.avatar === 'string' && !!value.avatar) {
          this.initialImage = this.generateDownloadURL('usuarios', value.avatar)
        }

        this.showCroppa = true
      }
    }
  },
  methods: {
    options (optionDate) {
      return optionDate <= date.formatDate(date.subtractFromDate(new Date(), { year: 18 }), 'YYYY/MM/DD')
    }
  }
}
</script>
